@echo off

rem
rem @(#) Script mise-a-jour HPU (Windows)
rem
rem
rem Argument 1 : contexte "INST" (installation) ou "UNINST" (desinstallation)
rem Argument 2 : repertoire d'installation de HPU (uniquement contexte "INST")
rem
rem
rem
rem Attention :
rem - La liste des fichiers a recopier dans le repertoire en vue de la 
rem   desinstallation est a modifier en cas d'ajout/suppression de fichiers.
rem   (Commentaire "Recopie des fichiers necessaires pour la desinstallation" dans
rem   ce script)
rem
rem Notes :
rem
rem - Le script n'est pas compatible Win98/WinMe
rem   La version est identifiee mais le resultat n'est pas exploite actuellement.
rem   Lignes de commande incompatibles :
rem   - cd /d
rem   - rmdir /s/q 
rem   - for
rem
rem - La commande "echo/" ou "echo." permet d'afficher une ligne vide.
rem
rem - Les etiquettes sont reconnues qu'avec les 8 premiers caracteres.
rem   ("I_xxx" pour les etiquettes en mode "INST", "U_xxx" pour les etiquettes en mode "UNINST")
rem
rem - Fichiers generes/utilises : 
rem   trace_version.txt
rem   ligne.txt
rem   mot.txt
rem
rem

rem ### DEBUG ###
rem pause
rem ### FIN DEBUG ###

echo.

rem Controle arguments d'appel

if "%~1" == "" goto ERR_PARAM

rem # if not "%2" == "" goto ERR_PARAM




rem Localisation des variables d'environnement dans le script uniquement


rem "enabledelayedexpansion" permet de modifier des variables dans une boucle 
rem "for" et de les exploiter avec !variable!
setlocal enabledelayedexpansion





set CONTEXT=%1
if "%CONTEXT%" == "INST" goto I_CHECK_2ND_PARAM
if "%CONTEXT%" == "UNINST" goto U_CHECK_2ND_PARAM

:I_CHECK_2ND_PARAM

if "%~2" == "" goto ERR_PARAM
if not "%~3" == "" goto ERR_PARAM

set LOCATION_PATH=%~2

goto IU_SUITE


:U_CHECK_2ND_PARAM

rem Un seul parametre d'appel en desinstallation

if not "%~2" == "" goto ERR_PARAM

goto IU_SUITE





:IU_SUITE


rem Obtention du repertoire ou se trouve le script de la mise-a-jour

rem Repertoire complet obtenu a partir du chemin complet du fichier de commande execute
set DIR_UPDATE=%~d0%~p0

rem Retrait du "\" en fin
rem Probleme eventuel si le resultat se reduit a la racine d'une unite disque
set DIR_UPDATE=%DIR_UPDATE:~0,-1%



rem Determination repertoire d'installation a partir de DIR_UPDATE
rem (desinstallation uniquement)
if "%CONTEXT%" == "UNINST" (

cd "%DIR_UPDATE%"
cd ..
cd ..

for /f "tokens=*"  %%p in ('cd') do (
set VAR_TMP=%%p
)

set LOCATION_PATH=!VAR_TMP!
cd "%DIR_UPDATE%"
)

rem ### DEBUG ###
rem echo LOCATION_PATH : "%LOCATION_PATH%"
rem ### FIN DEBUG ###

if not exist "%LOCATION_PATH%" (
   echo HPU installation directory "%LOCATION_PATH%" not found 1>&2
   goto END
)





rem ##########################
rem Identification version DOS
rem ##########################

rem L'identification de la version du DOS est uniquement indicative

:IDENT_DOS


set DOSVERSION=UNKNOWN

ver | find "MS-DOS Version 6.22" >NUL
if not errorlevel 1 set DOSVERSION=MSDOS622

ver | find "Windows 95" >NUL
if not errorlevel 1 set DOSVERSION=WIN95

ver | find "Windows 98" >NUL
if not errorlevel 1  set DOSVERSION=WIN98

ver | find "Windows Millennium">NUL
if not errorlevel 1 set DOSVERSION=WINME

ver | find "Windows NT" >NUL
if not errorlevel 1 set DOSVERSION=WINNT

ver | find "Windows 2000" >NUL
if not errorlevel 1 set DOSVERSION=WIN2000

ver | find "Windows XP" >NUL
if not errorlevel 1 set DOSVERSION=WINXP

rem if %DOSVERSION% == UNKNOWN goto ERR_DOS





rem ##############################
rem Configuration fichier de trace
rem ##############################

set FILE_TRACE=XXXX
if "%CONTEXT%"=="INST" set FILE_TRACE=%DIR_UPDATE%\trace_install_update_hpu.txt
if "%CONTEXT%"=="UNINST" set FILE_TRACE=%DIR_UPDATE%\trace_uninstall_update_hpu.txt
if "%FILE_TRACE%"=="XXXX" goto ERR_PAR1 

rem Vidage fichier de trace
echo\ > "%FILE_TRACE%"

date /t >> "%FILE_TRACE%"
time /t >> "%FILE_TRACE%"


rem Traces a present que le fichier de trace existe


echo DOS version            : %DOSVERSION%  >> "%FILE_TRACE%"
echo/  >> "%FILE_TRACE%"

echo Output of VER command  :  >> "%FILE_TRACE%"
ver  >> "%FILE_TRACE%"

echo.                          >> "%FILE_TRACE%"
echo DIR_UPDATE : %DIR_UPDATE% >> "%FILE_TRACE%"
echo.                          >> "%FILE_TRACE%"



echo.
echo.

rem ##################################################
rem Lecture du fichier des variables de la mise-a-jour
rem ##################################################


cd /d "%DIR_UPDATE%"



for /f "tokens=1-2 delims== " %%a in (
 update_variables.txt
) do set %%a=%%b



echo.                                            >> "%FILE_TRACE%"
echo UPDATE_LABEL        : %UPDATE_LABEL%        >> "%FILE_TRACE%"
echo UPDATE_TYPE         : %UPDATE_TYPE%         >> "%FILE_TRACE%"
echo VERSION_UPDATE      : %VERSION_UPDATE%      >> "%FILE_TRACE%"
echo VERSION_UPDATE_BASE : %VERSION_UPDATE_BASE% >> "%FILE_TRACE%"
echo UPDATE_OS           : %UPDATE_OS%           >> "%FILE_TRACE%"
echo.                                            >> "%FILE_TRACE%"

set UPDATE_CATEGORY=Update
if "%UPDATE_TYPE%"=="INTERIM_FIX" set UPDATE_CATEGORY=Interim Fix
if "%UPDATE_TYPE%"=="HOT_FIX" set UPDATE_CATEGORY=Hot Fix



echo HPU installation directory : %LOCATION_PATH%  >> "%FILE_TRACE%"







set FILE_CONFIG=%LOCATION_PATH%\INSTALL\hpu_cfg.bat


rem Recuperation valeur de STANDALONE_INSTALLATION a partir de HPU_INST.CFG
rem 

(echo Use of file %FILE_CONFIG%)  >> "%FILE_TRACE%"

call "%FILE_CONFIG%"

echo.  >> "%FILE_TRACE%"
echo STANDALONE_INSTALLATION         : "%STANDALONE_INSTALLATION%"   >> "%FILE_TRACE%"

if %STANDALONE_INSTALLATION% == 1 (echo No plug-in present  >> "%FILE_TRACE%")
if %STANDALONE_INSTALLATION% == 0 (echo Plug-in present  >> "%FILE_TRACE%")

echo.







rem #####################################
rem Recuperation du repertoire du plug-in
rem #####################################



rem Recuperation repertoire DB2 via la base de registres
rem
rem Fichier resultat_reg.txt temporaire a supprimer
rem

rem Recuperation dans "HKEY_LOCAL_MACHINE SOFTWARE\IBM\DB2" de "DB2 Path Name"

"%DIR_UPDATE%\getregistry" > resultat_reg.txt

if not "%errorlevel%"=="0" goto ERR_DB2_LOCATION
for /F "Tokens=*"  %%V in ('type resultat_reg.txt') do set DB2_INSTALL_DIR=%%V



echo.                                    >> "%FILE_TRACE%" 
echo DB2_INSTALL_DIR : %DB2_INSTALL_DIR% >> "%FILE_TRACE%"
echo.                                    >> "%FILE_TRACE%" 






if exist "%DB2_INSTALL_DIR%\cc" set DB2_DIR=%DB2_INSTALL_DIR%\cc
if exist "%DB2_INSTALL_DIR%\tools" set DB2_DIR=%DB2_INSTALL_DIR%\tools

echo.                                    >> "%FILE_TRACE%"
echo DB2_DIR         : %DB2_DIR%         >> "%FILE_TRACE%"
echo.                                    >> "%FILE_TRACE%"


rem ###############################
rem Verification fichiers d'actions
rem ###############################

set FILE_ACTIONS_INSTALL=install_update_actions.txt
set FILE_ACTIONS_UNINSTALL=uninstall_update_actions.txt

if not exist "%DIR_UPDATE%\%FILE_ACTIONS_INSTALL%" (
   echo     File "%DIR_UPDATE%\%FILE_ACTIONS_INSTALL%" not found.  >> "%FILE_TRACE%"
   echo     File "%DIR_UPDATE%\%FILE_ACTIONS_INSTALL%" not found.  1>&2
   goto END
)


rem ############################################
rem Verification applicabilite de la mise-a-jour
rem ############################################


rem 
rem Recuperation du numero de version HPU
rem 

if "%CONTEXT%"=="INST" goto CHECK_INST_VERSION
if "%CONTEXT%"=="UNINST" goto CHECK_UNINST_VERSION
goto ERR_CONTEXT


:CHECK_INST_VERSION

rem
rem >>> Fichier temporaire trace_version.txt a supprimer !!!!
rem

rem Appel de db2hpu avec CALL sinon pas de continuation du script aprs

call db2hpu -v > trace_version.txt 2>&1

echo.                                  >> "%FILE_TRACE%"
echo Fichier trace_version.txt         >> "%FILE_TRACE%"
echo.                                  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"
type trace_version.txt  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"


rem for /F "usebackq delims=:( tokens=1,2,3" %%i in (trace_version.txt) do (
rem set RESULTAT=%%j)
rem 
rem 
rem for /F "usebackq tokens=1,2" %%p in (`echo %RESULTAT%`) do (
rem set VERSION_NUMBER=%%q)

rem  Recuperation du message dans une variablr
for /F "usebackq tokens=*" %%i in (trace_version.txt) do (
set LIGNE_VERSION=%%i)


set MOT=%LIGNE_VERSION%

rem echo MOT : %MOT% 
rem echo.


copy trace_version.txt ligne.txt >NUL


rem Boucle d'extraction de chaque mot du message (ligne de texte contenant le numero de version)
rem MOT   : contient le premier mot du message
rem RESTE : contient les autres mots du message
rem
rem A chaque interation : on examine le message 
rem - le premier mot est extrait, 
rem - le reste des mots forment le message a examiner pour la prochaine iteration
rem
rem
rem
rem

set RESTE=XXXXXXXXXXXXXXXX

:I_PARSE_VERSION


rem Plus de mots a examiner : erreur
if "%RESTE%" == "" goto ERR_HPU_VERSION

rem Extraction du premier mot et du reste du message
for /F "tokens=1,*" %%i in (ligne.txt) do (
set MOT=%%i
set RESTE=%%j
)

rem echo.
rem echo MOT   : %MOT% 
rem echo RESTE : %RESTE% 
rem echo.

rem Pour examiner le mot, placement de celui-ci dans un fichier pour utiliser "findstr"
echo %MOT% > mot.txt



rem Recherche chaine du type "nn.cccc...cc(nnnnn)ccc" dans le mot
rem
rem Apres la chaine elle-meme, il y a d'autres caracteres (CR + LF)
rem findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt
rem Si la chaine n'est pas trouvee, "findstr" ne retourne rien.

rem Si le "findstr" ne retourne rien, le traitement du "for" n'est pas
rem execute et RESULTAT contient encore la valeur de l'iteration precedente.
set RESULTAT=

for /F "tokens=*" %%v in ('findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt') do (
set RESULTAT=%%v)


rem echo Resultat de recherche : %RESULTAT%
if not "%RESULTAT%" == "" goto I_VER_FOUND

rem pause
rem echo.
rem echo.

rem Constitution du message a examiner pour iteration suivante
echo %RESTE% > ligne.txt

goto I_PARSE_VERSION



:I_VER_FOUND

echo Found version information : >> "%FILE_TRACE%"
echo RESULTAT : "%RESULTAT%"     >> "%FILE_TRACE%"




rem Extraction du numero de version "nn.nn.nnn" a partir de la chaine "nn.nn.nnn(nnnnnn)"
for /F "usebackq delims=() tokens=1,2,3" %%p in ("mot.txt") do (
set VERSION_NUMBER=%%p )



rem echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"

rem Suppression espace superflu en fin (cause presence inconnue)
set VERSION_NUMBER=%VERSION_NUMBER:~0,-1%

echo.                                    >> "%FILE_TRACE%"
echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"



rem 
rem Controle de la compatibilite entre version et update
rem 


rem Indentation bizarre sinon erreurs de syntaxe

if "%VERSION_NUMBER%" GTR "%VERSION_UPDATE%"  (echo Version %VERSION_NUMBER% is too high to apply update %UPDATE_LABEL%
    echo Version %VERSION_NUMBER% is too high to apply update %UPDATE_LABEL% >> "%FILE_TRACE%"
    goto END) else (
     if "%VERSION_NUMBER%" EQU "%VERSION_UPDATE%"  (echo Version %VERSION_NUMBER% is already installed
         echo Version %VERSION_NUMBER% is already installed >> "%FILE_TRACE%"
         goto END) else (          
          if "%VERSION_NUMBER%" LSS "%VERSION_UPDATE_BASE%" (echo Version %VERSION_NUMBER% is too low to apply update %UPDATE_LABEL%
               echo Version %VERSION_NUMBER% is too low to apply update %UPDATE_LABEL% >> "%FILE_TRACE%"
               goto END) else (
            echo Found version %VERSION_NUMBER%, update %UPDATE_LABEL% to version %VERSION_UPDATE% can be applied
            echo Found version %VERSION_NUMBER%, update %UPDATE_LABEL% to version %VERSION_UPDATE% can be applied  >> "%FILE_TRACE%")
       )
 )


goto SUITE_INSTALL


:CHECK_UNINST_VERSION

rem
rem >>> Fichier temporaire trace_version.txt a supprimer !!!!
rem

rem Appel de db2hpu avec CALL sinon pas de continuation du script aprs

call db2hpu -v > trace_version.txt 2>&1

echo.                                  >> "%FILE_TRACE%"
echo Fichier trace_version.txt         >> "%FILE_TRACE%"
echo.                                  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"
type trace_version.txt  >> "%FILE_TRACE%"
echo --------------     >> "%FILE_TRACE%"


rem for /F "usebackq delims=:( tokens=1,2,3" %%i in (trace_version.txt) do (
rem set RESULTAT=%%j)
rem 
rem 
rem for /F "usebackq tokens=1,2" %%p in (`echo %RESULTAT%`) do (
rem set VERSION_NUMBER=%%q)

rem  Recuperation du message dans une variable
for /F "usebackq tokens=*" %%i in (trace_version.txt) do (
set LIGNE_VERSION=%%i)


set MOT=%LIGNE_VERSION%

rem echo MOT : %MOT% 
rem echo.


copy trace_version.txt ligne.txt >NUL


rem Boucle d'extraction de chaque mot du message (ligne de texte contenant le numero de version)
rem MOT   : contient le premier mot du message
rem RESTE : contient les autres mots du message
rem
rem A chaque interation : on examine le message 
rem - le premier mot est extrait, 
rem - le reste des mots forment le message a examiner pour la prochaine iteration
rem
rem
rem
rem

set RESTE=XXXXXXXXXXXXXXXX

:U_PARSE_VERSION


rem Plus de mots a examiner : erreur
if "%RESTE%" == "" goto ERR_HPU_VERSION

rem Extraction du premier mot et du reste du message
for /F "tokens=1,*" %%i in (ligne.txt) do (
set MOT=%%i
set RESTE=%%j
)

rem echo.
rem echo MOT   : %MOT% 
rem echo RESTE : %RESTE% 
rem echo.

rem Pour examiner le mot, placement de celui-ci dans un fichier pour utilsier "findstr"
echo %MOT% > mot.txt



rem Recherche chaine du type "nn.cccc...cc(nnnnn)ccc" dans le mot
rem
rem Apres la chaine elle-meme, il y a d'autres caracteres (CR + LF)
rem findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt
rem Si la chaine n'est pas trouvee, "findstr" ne retourne rien.

rem Si le "findstr" ne retourne rien, le traitement du "for" n'est pas
rem execute et RESULTAT contient encore la valeur de l'iteration precedente.
set RESULTAT=

for /F "tokens=*" %%v in ('findstr "^[0-9][0-9]\..*([0-9][0-9][0-9][0-9][0-9][0-9]).*$" mot.txt') do (
set RESULTAT=%%v)


rem echo Resultat de recherche : %RESULTAT%
if not "%RESULTAT%" == "" goto U_VER_FOUND

rem pause
rem echo.
rem echo.

rem Constitution du message a examiner pour iteration suivante
echo %RESTE% > ligne.txt

goto U_PARSE_VERSION



:U_VER_FOUND

echo Found version information : >> "%FILE_TRACE%"
echo RESULTAT : "%RESULTAT%"     >> "%FILE_TRACE%"




rem Extraction du numero de version "nn.nn.nnn" a partir de la chaine "nn.nn.nnn(nnnnnn)"
for /F "usebackq delims=() tokens=1,2,3" %%p in ("mot.txt") do (
set VERSION_NUMBER=%%p )




rem Suppression espace superflu en fin (cause presence inconnue)
set VERSION_NUMBER=%VERSION_NUMBER:~0,-1%

echo.                                    >> "%FILE_TRACE%"
echo VERSION_NUMBER : "%VERSION_NUMBER%" >> "%FILE_TRACE%"



rem 
rem Controle de la compatibilite entre version et update
rem 



rem Indentation bizarre sinon erreurs de syntaxe

if "%VERSION_NUMBER%" GTR "%VERSION_UPDATE%"  (echo Current version %VERSION_NUMBER% is too high to uninstall the update %UPDATE_LABEL%
    (echo Current version %VERSION_NUMBER% is too high to uninstall the update %UPDATE_LABEL%) >> "%FILE_TRACE%"
    goto END) else (
     if "%VERSION_NUMBER%" LSS "%VERSION_UPDATE%"  (echo Current version %VERSION_NUMBER% is older than update %UPDATE_LABEL%!
         (echo Uninstallation impossible)
         (echo Current version %VERSION_NUMBER% is older than update %UPDATE_LABEL%!) >> "%FILE_TRACE%"
         (echo Uninstallation impossible) >> "%FILE_TRACE%"
         goto END) else (          
          if "%VERSION_NUMBER%" EQU "%VERSION_UPDATE%" (echo Current version is %VERSION_NUMBER%, uninstallation of %UPDATE_LABEL% can be done.
               (echo Current version is %VERSION_NUMBER%, uninstallation of %UPDATE_LABEL% can be done.) >> "%FILE_TRACE%")
       )
 )


goto SUITE_UNINSTALL


rem #######################################################################
rem # Installation
rem #######################################################################

:SUITE_INSTALL

rem Liste des mises-a-jour deja installees
rem 
rem Methode utilisee : liste des fichiers executables db2hpum_debug_XXXX
rem Pb : les noms sont des noms de abreges pour les noms de fichiers et ne sont pas
rem les noms officiels des mises-a-jour.  
rem
rem Non realise


echo/ 
echo -------------------------------------------------------------------
echo/ 
echo High Performance Unload
echo/
echo %UPDATE_CATEGORY% %UPDATE_LABEL% for Windows operating system
echo/ 
echo/ 
echo -------------------------------------------------------------------


echo/ 
echo The update will be applied to the version located at 
echo %LOCATION_PATH%
echo/ 


echo/                                     >> "%FILE_TRACE%"
echo Context                : "%CONTEXT%" >> "%FILE_TRACE%"
echo/                                     >> "%FILE_TRACE%"




echo All replaced files will be renamed by adding the "_%UPDATE_LABEL%" extension
echo. 
echo You must be the "Administrator" user in order to run this update
echo The HPU network service must be stopped
echo.

:ANSWER_INST

echo Type "install" to continue or "quit" to abort:
echo. (The answer is case sensitive)
echo.

set /p RESPONSE=

echo RESPONSE : "%RESPONSE%" >> "%FILE_TRACE%"
echo.

if "%RESPONSE%" == "install" goto CONT_INST
if "%RESPONSE%" == "quit" goto ABORT_INST

goto ANSWER_INST

:CONT_INST




echo/               
echo Installing...  

echo/               >> "%FILE_TRACE%"
echo Installing...  >> "%FILE_TRACE%"



rem ############
rem Desarchivage
rem ############

echo/               
echo Extracting files from archive...  


rem Controle presence fichier archive

(echo Checking file archive_update_win32.zip) >> "%FILE_TRACE%"
if not exist archive_update_win32.zip goto ERR_NOT_FOUND

rem Extraction fichiers archive

(echo Extracting archive...)  >> "%FILE_TRACE%"

"%LOCATION_PATH%\install\unzip" -o archive_update_win32.zip  >> "%FILE_TRACE%"

rem Utiliser rpertoire temporaire ??? (il faut modifier tous les chemins !!)


rem ### DEBUG ###
rem del archive_update_win32.zip
rem ### FIN DEBUG ###


set LIST_FILE_ACTIONS_INSTALL=install_update_prolog_actions.txt %FILE_ACTIONS_INSTALL% install_update_epilog_actions.txt

rem Execution de tous les fichiers d'actions

call :EXE_ACTIONS %LIST_FILE_ACTIONS_INSTALL%





rem ########################################
rem Creation repertoire pour desinstallation
rem ########################################

echo.
echo Creating uninstall directory...
echo.

echo ==========================================================================  >> "%FILE_TRACE%"
echo Creating uninstall directory >> "%FILE_TRACE%"

echo.


 
if exist "%LOCATION_PATH%\ptf" (
  (echo Creating directory "%LOCATION_PATH%\ptf\%UPDATE_LABEL%") >> "%FILE_TRACE%"
  mkdir "%LOCATION_PATH%\ptf\%UPDATE_LABEL%"
 ) else (
   (echo Creating directory ptf "%LOCATION_PATH%\ptf") >> "%FILE_TRACE%"
   mkdir "%LOCATION_PATH%\ptf" 
   (echo Creating directory "%LOCATION_PATH%\ptf\%UPDATE_LABEL%") >> "%FILE_TRACE%"
   mkdir "%LOCATION_PATH%\ptf\%UPDATE_LABEL%"
 ) 

 
rem Recopie des fichiers necessaires pour la desinstallation

(echo Populating files in "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" directory) >> "%FILE_TRACE%"

copy "%DIR_UPDATE%\hpu_update.bat" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\uninstall_update_hpu.bat" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"

copy "%DIR_UPDATE%\update_variables.txt" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\InstallInstructions.txt" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\GetRegistry.exe" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"

copy "%DIR_UPDATE%\install_update_actions.txt" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\uninstall_update_prolog_actions.txt" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\uninstall_update_epilog_actions.txt" "%LOCATION_PATH%\ptf\%UPDATE_LABEL%" >> "%FILE_TRACE%"



echo.                       
echo Installation completed 
echo.                      



echo.                         >> "%FILE_TRACE%"
(echo Installation completed) >> "%FILE_TRACE%"
echo.                         >> "%FILE_TRACE%"


goto END






rem #######################################################################
rem # Desinstallation
rem #######################################################################

:SUITE_UNINSTALL


rem Liste des mises-a-jour deja installees
rem 
rem Methode utilisee : liste des fichiers executables db2hpum_debug_XXXX
rem Pb : les noms sont des noms de abreges pour les noms de fichiers et ne sont pas
rem les noms officiels des mises-a-jour.  
rem
rem Non realise


echo/ 
echo -------------------------------------------------------------------
echo/ 
echo High Performance Unload
echo/
echo %UPDATE_CATEGORY% %UPDATE_LABEL% for Windows operating system
echo/ 
echo/ 
echo -------------------------------------------------------------------

echo/ 
echo The update will be removed from the version located at 
echo %LOCATION_PATH%
echo/ 


echo. 
echo You must be the "Administrator" user in order to run this update
echo The HPU network service must be stopped
echo.

:ANSWER_UNINST

echo Type "uninstall" to continue or "quit" to abort:
echo. (The answer is case sensitive)
echo.

set /p RESPONSE=

echo RESPONSE : "%RESPONSE%" >> "%FILE_TRACE%"
echo.

if "%RESPONSE%" == "uninstall" goto CONT_UNINST
if "%RESPONSE%" == "quit" goto ABORT_UNINST

goto ANSWER_UNINST

:CONT_UNINST



echo/               
echo Uninstalling...

echo/                 >> "%FILE_TRACE%"
echo Uninstalling...  >> "%FILE_TRACE%"



set LIST_FILE_ACTIONS_UNINSTALL=uninstall_update_prolog_actions.txt %FILE_ACTIONS_UNINSTALL% uninstall_update_epilog_actions.txt

rem Creation du fichier des actions en desinstallation par inversion des lignes
rem du fichier des actions en installation

call :REVERSE_FILE "%FILE_ACTIONS_INSTALL%" "%FILE_ACTIONS_UNINSTALL%"


rem Execution de tous les fichiers d'actions

call :EXE_ACTIONS %LIST_FILE_ACTIONS_UNINSTALL%



echo.                         
echo Uninstallation completed 
echo.                         

echo.                         >> "%FILE_TRACE%"
echo Uninstallation completed >> "%FILE_TRACE%"
echo.                         >> "%FILE_TRACE%"



goto END




rem #########################################################################
rem UPDDIR_INST
rem #########################################################################

rem
rem Action UPDATE_DIRECTORY mode installation
rem
rem Les sorties standard des COPY doivent etre redirigees vers les traces 
rem Les sorties des erreur des COPY doivent apparaitre quelque part pour 
rem qu'elles soient detectees
rem 

:UPDDIR_INST

(echo.)                    >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR_INST)  >> "%FILE_TRACE%"

set RETURN_CODE=0

set ARG_1=%1


rem Si le repertoire n'est pas dans l'archive extraite, on ne le traite pas
rem (Pas d'erreur pour plus de souplesse)

if not exist "%DIR_UPDATE%\!ARG_1!" (
   (echo     Directory "!ARG_1!" not found in %UPDATE_CATEGORY% archive) >> "%FILE_TRACE%"
   (echo     No files to update in directory "!ARG_1!")                  >> "%FILE_TRACE%"
   goto :EOF
)


rem Si le repertoire n'existe pas dans l'arborescence HPU, il est cree

if not exist "%LOCATION_PATH%\!ARG_1!" (
   (echo      Creating directory "%LOCATION_PATH%\!ARG_1!")  >> "%FILE_TRACE%"
   mkdir "%LOCATION_PATH%\!ARG_1!"
)


cd /d "%DIR_UPDATE%\!ARG_1!"

rem Controle si le repertoire est vide (de fichies)
rem S'il ne contient pas de fichiers, dans le "for" plus bas "dir /b /a:-d" 
rem affichera un message "File not found"

dir /b /a:-d >NUL 2>&1
if errorlevel 1 goto :NO_FILES

rem Traitement des fichiers seuls (exclusion des sous-repertoires)

for /f "usebackq" %%a in (`dir /b /a:-d`) do (
echo.                 >> "%FILE_TRACE%"
echo     File : "%%a" >> "%FILE_TRACE%"

echo     File "%LOCATION_PATH%\!ARG_1!\%%a" >> "%FILE_TRACE%"

if exist "%LOCATION_PATH%\!ARG_1!\%%a" (
echo     Existing file found.  >> "%FILE_TRACE%"
echo.                          >> "%FILE_TRACE%"
echo     Backing up file...    >> "%FILE_TRACE%"

rem Pas d'utilisation de rename car probleme pour obtenir le second argument conforme
rem a la syntaxe de la commande (nom seul sans chemin)

copy "%LOCATION_PATH%\!ARG_1!\%%a" "%LOCATION_PATH%\!ARG_1!\%%a_%UPDATE_LABEL%" >NUL 
if errorlevel 1 (
   echo Error while backing up file >> "%FILE_TRACE%"
   echo Error while backing up file 1>&2
   echo Source file      : %DIR_UPDATE%\!ARG_1!\%%a 1>&2
   echo Destination file : %LOCATION_PATH%\!ARG_1!\%%a_%UPDATE_LABEL% 1>&2
   set RETURN_CODE=3
)

echo.                        >> "%FILE_TRACE%"
echo     Copying new file... >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\!ARG_1!\%%a" "%LOCATION_PATH%\!ARG_1!\%%a" >NUL 
if errorlevel 1 (
   echo Error while copying new file >> "%FILE_TRACE%"
   echo Error while copying new file 1>&2
   echo Source file      : %DIR_UPDATE%\!ARG_1!\%%a 1>&2
   echo Destination file : %LOCATION_PATH%\!ARG_1!\%%a 1>&2
   set RETURN_CODE=3
)



) else (
echo     No actual file found.  >> "%FILE_TRACE%"
echo.                           >> "%FILE_TRACE%"

rem Creation d'un fichier vide en lieu de la version precedente du 
rem fichier 
rem Creation du fichier vide par resultat d'un "dir" sans resultat
dir /b XXXX >"%LOCATION_PATH%\!ARG_1!\%%a_%UPDATE_LABEL%"  2>NUL
                   
echo     Copying new file...    >> "%FILE_TRACE%"
copy "%DIR_UPDATE%\!ARG_1!\%%a" "%LOCATION_PATH%\!ARG_1!" >NUL
if errorlevel 1 (
   echo Error while copying new file >> "%FILE_TRACE%"
   echo Error while copying new file 1>&2
   echo Source file      : %DIR_UPDATE%\!ARG_1!\%%a 1>&2
   echo Destination file : %LOCATION_PATH%\!ARG_1!\%%a 1>&2
   set RETURN_CODE=3
)


)

)

:NO_FILES


rem Restauration repertoire courant
cd /d "%DIR_UPDATE%"

(echo.)                        >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR_INST exit) >> "%FILE_TRACE%"


goto :EOF



rem #########################################################################
rem UPDDIR_UNINST
rem #########################################################################

rem
rem Action UPDATE_DIRECTORY mode desinstallation
rem


:UPDDIR_UNINST

(echo.)                     >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR_UNINST) >> "%FILE_TRACE%"

set RETURN_CODE=0


set ARG_1=%1


rem Si le repertoire n'est pas trouve, pas d'erreur

if not exist "%LOCATION_PATH%\!ARG_1!" (
   (echo     Directory "%LOCATION_PATH%\!ARG_1!" not found)  >> "%FILE_TRACE%"
   (echo     No files to restore in directory "!ARG_1!")     >> "%FILE_TRACE%"
   goto :EOF
)

echo.                        >> "%FILE_TRACE%"
echo     Restoring files...  >> "%FILE_TRACE%"
echo.                        >> "%FILE_TRACE%"


cd /d "%LOCATION_PATH%\!ARG_1!"


del dir_error 1>NUL 2>&1

dir /b *_%UPDATE_LABEL% 1>NUL 2>dir_error
call :CHK_EMPTY_FILE "dir_error"
if errorlevel 29 (

echo     No file to restore  >> "%FILE_TRACE%"
del dir_error 1>NUL 2>&1

goto :EOF
) 

del dir_error 1>NUL 2>&1

for /f "usebackq" %%a in (`dir /b *_%UPDATE_LABEL%`) do (

echo.                                        >> "%FILE_TRACE%"
echo     File : "%%a"                        >> "%FILE_TRACE%"
echo     File "%LOCATION_PATH%\!ARG_1!\%%a"  >> "%FILE_TRACE%"

set FILE_NAME=%%a
rem Suppression du suffixe pour obtenir le nom original
rem >>> La valeur constante est a calculer : longueur de UPDATE_LABEL + 1 !!!
set NAME_TMP=!FILE_NAME:~0,-8!
rem echo     NAME_TMP : !NAME_TMP!
      
if exist "!NAME_TMP!" (
echo     Backup file found            >> "%FILE_TRACE%"
echo.                                 >> "%FILE_TRACE%"
call :CHK_EMPTY_FILE "!FILE_NAME!"

if errorlevel 29 (
echo     File non empty               >> "%FILE_TRACE%"

echo.                                 >> "%FILE_TRACE%"
echo     Restoring from backup file   >> "%FILE_TRACE%"
   
copy "%LOCATION_PATH%\!ARG_1!\%%a" "%LOCATION_PATH%\!ARG_1!\!NAME_TMP!" >NUL 
if errorlevel 1 (
   echo Error while restoring file from backup file >> "%FILE_TRACE%"
   echo Error while restoring file from backup file 1>&2
   echo Backup file : %%a 1>&2
   echo Destination file : !NAME_TMP! 1>&2
   set RETURN_CODE=3
)

echo.                         >> "%FILE_TRACE%"
echo     Removing backup file >> "%FILE_TRACE%"
del "%LOCATION_PATH%\!ARG_1!\%%a"  
if errorlevel 1 (
   rem Les cas de fichier en cours d'utilisation ou protege contre l'ecriture ne
   rem pas detectes par errorlevel !
   echo Error while removing file >> "%FILE_TRACE%"
   echo Error while removing file 1>&2
   echo File : %LOCATION_PATH%\!ARG_1!\%%a 1>&2
   set RETURN_CODE=3
)

) else (
echo     Empty file                                              >> "%FILE_TRACE%"
echo     Backup file empty: no previous existing file to restore >> "%FILE_TRACE%"
echo     Removing actual file                                    >> "%FILE_TRACE%"
del "%LOCATION_PATH%\!ARG_1!\!NAME_TMP!"  
if errorlevel 1 (
   rem Les cas de fichier en cours d'utilisation ou protege contre l'ecriture ne
   rem pas detectes par errorlevel !
   echo Error while removing file >> "%FILE_TRACE%"
   echo Error while removing file 1>&2
   echo File : %LOCATION_PATH%\!ARG_1!\!NAME_TMP! 1>&2
   set RETURN_CODE=3
)


echo     Removing backup file  >> "%FILE_TRACE%"
del "%LOCATION_PATH%\!ARG_1!\%%a"  
if errorlevel 1 (
   rem Les cas de fichier en cours d'utilisation ou protege contre l'ecriture ne
   rem pas detectes par errorlevel !
   echo Error while removing file >> "%FILE_TRACE%"
   echo Error while removing file 1>&2
   echo File : %LOCATION_PATH%\!ARG_1!\%%a 1>&2
   set RETURN_CODE=3
)


)
) else (
rem Aucun fichier trouve
echo     No file found  >> "%FILE_TRACE%"



)

rem "for"
)

rem Restauration repertoire courant
cd /d "%DIR_UPDATE%"
  
  
(echo.)                          >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR_UNINST exit) >> "%FILE_TRACE%"

goto :EOF



rem #########################################################################
rem UPDDIR
rem #########################################################################

rem
rem Action UPDATE_DIRECTORY 
rem
rem Arguments d'appel
rem 1 : nom de sous-repertoire (du repertoire d'installation) a mettre a jour

:UPDDIR

(echo.)                >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR)  >> "%FILE_TRACE%"

set RETURN_CODE=0


set ARG_1=%~1
set ARG_2=%~2
set ARG_3=%~3
set ARG_4=%~4
set ARG_5=%~5


rem ### DEBUG ###
echo     ARG_1: "%ARG_1%"  >> "%FILE_TRACE%"
echo     ARG_2: "%ARG_2%"  >> "%FILE_TRACE%"
echo     ARG_3: "%ARG_3%"  >> "%FILE_TRACE%"
echo     ARG_4: "%ARG_4%"  >> "%FILE_TRACE%"
echo     ARG_5: "%ARG_5%"  >> "%FILE_TRACE%"
rem ### FIN DEBUG ###

if "%ARG_1%" == "" (
echo Missing arguments >> "%FILE_TRACE%"
echo Missing arguments 1>&2
set RETURN_CODE=1
goto :EOF
)


if "%ARG_2%" == "" (
echo     No condition present: action always executed  >> "%FILE_TRACE%"
set RES_EXPR=1
goto :NO_EVAL
) 

if "%ARG_5%" == "" (
if "%ARG_4%" == "" (
echo Missing or too many arguments  >> "%FILE_TRACE%"
echo Missing or too many arguments 1>&2
set RETURN_CODE=1
goto :EOF
)
) else (
echo Too many arguments  >> "%FILE_TRACE%"
echo Too many arguments 1>&2
set RETURN_CODE=1
goto :EOF
)
 

echo     Condition present >> "%FILE_TRACE%"
rem Ajout du caractere "%" autour du nom de la variable en vue de son 
rem evaluation
set ARG_VAR=%%%ARG_2%%%
set ARG_OPER=%ARG_3%
set ARG_VAL=%ARG_4%

echo     ARG_VAR  : "!ARG_VAR!"   >> "%FILE_TRACE%"
echo     ARG_OPER : "!ARG_OPER!"  >> "%FILE_TRACE%"
echo     ARG_VAL  : "!ARG_VAL!"   >> "%FILE_TRACE%"


(echo.)                                                 >> "%FILE_TRACE%"
echo     Retrieval of value of identifier "!ARG_VAR!"  >> "%FILE_TRACE%"
call :EVALUATE !ARG_VAR!
echo     Value of identifier "!ARG_VAR!" : "!ARG_EVAL!"  >> "%FILE_TRACE%"


rem Evaluation de l'expression

echo     Expression to evaluate : "!ARG_EVAL! !ARG_OPER! !ARG_VAL!"  >> "%FILE_TRACE%"
if "!ARG_OPER!" == "EQ" goto :EVAL_EQ
if "!ARG_OPER!" == "NE" goto :EVAL_NE
if "!ARG_OPER!" == "GT" goto :EVAL_GT
if "!ARG_OPER!" == "LT" goto :EVAL_LT
if "!ARG_OPER!" == "GE" goto :EVAL_GE
if "!ARG_OPER!" == "LE" goto :EVAL_LE
(echo Unknown operator "!ARG_OPER!" for expression) >> "%FILE_TRACE%"
(echo Unknown operator "!ARG_OPER!" for expression) 1>&2
set RETURN_CODE=1
goto :EOF

:EVAL_EQ
rem Evaluation EQ (egalite)

if !ARG_EVAL! EQU !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL


:EVAL_NE
rem Evaluation NE (difference)

if !ARG_EVAL! NEQ !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL


:EVAL_GT
rem Evaluation GT (superieur strict)
if !ARG_EVAL! GTR !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL



:EVAL_LT
rem Evaluation LT (inferieur strict)

if !ARG_EVAL! LSS !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL


:EVAL_GE
rem Evaluation GE (superieur ou egal)

if !ARG_EVAL! GEQ !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL

:EVAL_LE
rem Evaluation GE (inferieur ou egal)

if !ARG_EVAL! LEQ !ARG_VAL! (
set RES_EXPR=1
) else (
set RES_EXPR=0
)
goto :FIN_EVAL


:FIN_EVAL
(echo.)                >> "%FILE_TRACE%"

if !RES_EXPR! EQU 1 (
echo     Condition result: true   >> "%FILE_TRACE%"
echo     Action will be executed  >> "%FILE_TRACE%"
) else (
echo     Condition result: false   >> "%FILE_TRACE%"
echo     Action won't be executed  >> "%FILE_TRACE%"
)

:NO_EVAL


(echo.)                >> "%FILE_TRACE%"




if !RES_EXPR! EQU 1 (

if "%CONTEXT%" == "INST" (
rem Action UPDATE_DIRECTORY INST
call :UPDDIR_INST %*
) else (

if "%CONTEXT%" == "UNINST" (
rem  Action UPDATE_DIRECTORY UNINST
call :UPDDIR_UNINST %*
)

)
)



(echo.)                    >> "%FILE_TRACE%"
(echo ^>^>^> UPDDIR exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem UPDLIF_INST
rem #########################################################################

rem
rem Action UPDATE_LINE_FILE mode installation
rem
rem Arguments d'appel :
rem 1 : chemin (relatif par rapport au repertoire d'installation ?) du fichier 
rem     a modifier 
rem 2 : debut de ligne du fichier a rechercher
rem 3 : ligne de remplacement
rem
rem Attention : 
rem Du fait de la limitation de certaines commandes Windows, le traitement sur  
rem le fichier lui fait perdre ses lignes (entierement) vides.
rem
rem Limitations :
rem - Seule la premiere occurrence de la ligne recherchee est traitee.
rem
rem Remarque : les parametres sont deja evalues (i.e. substitution des variables par leur valeur)
rem            (c'est apparement le passage des arguments aux differentes fonctions qui le fait)
rem


:UPDLIF_INST

(echo.)                    >> "%FILE_TRACE%"
(echo ^>^>^> UPDLIF_INST)  >> "%FILE_TRACE%"

set RETURN_CODE=0

rem echo 1 : "%1"
rem echo 2 : "%2"
rem echo 3 : "%3"
rem echo 4 : "%4"


set ARG_1=%~1
set ARG_2=%~2
set ARG_3=%~3
set ARG_4=%~4


rem echo ARG_1 : "!ARG_1!"
rem echo ARG_2 : "!ARG_2!"
rem echo ARG_3 : "!ARG_3!"
rem echo ARG_4 : "!ARG_4!"



set FILE=%LOCATION_PATH%\!ARG_1!
set LINE_TO_FIND=!ARG_2!
set LINE_NEW=!ARG_3!

echo     FILE         : "!FILE!"          >> "%FILE_TRACE%"
echo     LINE_TO_FIND : "!LINE_TO_FIND!"  >> "%FILE_TRACE%"
echo     LINE_NEW     : "!LINE_NEW!"      >> "%FILE_TRACE%"

rem Calcul longueur ligne recherchee
call :LENGTH "%LINE_TO_FIND%"
set LENGTH_LINE_TO_FIND=%VAL_CPT%

echo.                                            >> "%FILE_TRACE%"
echo     LENGTH_LINE_TO_FIND : %LENGTH_LINE_TO_FIND% >> "%FILE_TRACE%"



if not exist "!FILE!" (
   echo File "!FILE!" not found  >> "%FILE_TRACE%"
   echo File "!FILE!" not found 1>&2
   set RETURN_CODE=2
   goto :EOF
)


set FILE_OUTPUT=%FILE%_output
set RETURN_CODE=0

rem ### DEBUG ###
del "%FILE_OUTPUT%" >NUL 2>&1
rem ### FIN DEBUG ###


rem Controles existence
if not exist "%FILE%" (
(echo File "%FILE%" not found) 1>&2
set RETURN_CODE=1
goto :END
)

set SUBSTITUTION_DONE=0

rem Les lignes entierement vides sont sautees par "for"
rem for /f "usebackq tokens=1* delims==" %%a in (`type %FICHIER%`) do (
for /f "usebackq tokens=*" %%w in (`type "%FILE%"`) do (

rem echo.

set LINE=%%w
rem echo LINE  : "!LINE!"


rem Une ligne entierement vide n'est pas lue par le "for"
rem Une ligne contenant des espaces est lue comme vide
if "!LINE!" == "" (
rem Ligne vide qui contenait des espaces 
rem echo     Write of empty line
(echo. ) >> "%FILE_OUTPUT%"
) else (


set LINE_BEGINNING=XXX

call :EXTRBEGLIN %LENGTH_LINE_TO_FIND% "!LINE!"

echo.                                                               >> "%FILE_TRACE%"
echo     Extraction of the first %LENGTH_LINE_TO_FIND% characters:  >> "%FILE_TRACE%"
echo     LINE_BEGINNING : "!LINE_BEGINNING!"                        >> "%FILE_TRACE%"




if "!LINE_BEGINNING!" == "%LINE_TO_FIND%" (
echo     Line found                               >> "%FILE_TRACE%"
if "!SUBSTITUTION_DONE!" == "0" (
(echo %LINE_NEW%)  >> "%FILE_OUTPUT%"
echo     Line replaced                            >> "%FILE_TRACE%"
set SUBSTITUTION_DONE=1
 ) else (
 (echo !LINE!)  >> "%FILE_OUTPUT%"
 echo     Line not replaced: not first occurence  >> "%FILE_TRACE%"
)
) else (
(echo !LINE!)  >> "%FILE_OUTPUT%"


rem Fin "else"
)



)

)

if "!SUBSTITUTION_DONE!" == "0" (
(echo Line to search  not found!) >> "%FILE_TRACE%"
(echo Line to search  not found!) 1>&2
del "%FILE_OUTPUT%" >NUL 2>&1
set RETURN_CODE=1
) else (
copy "%FILE_OUTPUT%" "%FILE%" >NUL 2>&1
)


del "%FILE_OUTPUT%" >NUL 2>&1



(echo.)                         >> "%FILE_TRACE%"
(echo ^>^>^> UPDLIF_INST exit)  >> "%FILE_TRACE%"


goto :EOF

rem A mettre en oeuvre
rem exit /b %RETURN_CODE%




rem #########################################################################
rem UPDLIF_UNINST
rem #########################################################################

rem
rem Action UPDATE_LINE_FILE mode desinstallation
rem
rem Actuellement rien a faire, car les ficheis qui avaient ete modiifes ne 
rem sont pas a restaurer : ils seront supprimes
rem 

:UPDLIF_UNINST

(echo.)                      >> "%FILE_TRACE%"
(echo ^>^>^> UPDLIF_UNINST)  >> "%FILE_TRACE%"

set RETURN_CODE=0

set ARG_1=%~1
set ARG_2=%~2
set ARG_3=%~3
set ARG_4=%~4




set FILE=%LOCATION_PATH%\!ARG_1!
set LINE_TO_FIND=!ARG_2!
set LINE_NEW=!ARG_3!

echo     FILE         : "!FILE!"  >> "%FILE_TRACE%"
echo     LINE_TO_FIND : "!LINE_TO_FIND!"  >> "%FILE_TRACE%"
echo     LINE_NEW     : "!LINE_NEW!"  >> "%FILE_TRACE%"




echo     No uninstall treatment to do.  >> "%FILE_TRACE%"

(echo.)                           >> "%FILE_TRACE%"
(echo ^>^>^> UPDLIF_UNINST exit)  >> "%FILE_TRACE%"


goto :EOF





rem #########################################################################
rem UPDLINFILE
rem #########################################################################

rem
rem Action UPDATE_LINE_FILE
rem
rem Arguments d'appel :
rem 1 : fichier a modifier (chemin relatif au repertoire d'installation de HPU)
rem 2 : debut de ligne a rechercher (pour la remplacer)
rem 3 : ligne de remplacement
rem
rem Limitation : le fichier a modifier ne peut se trouver que dans 
rem l'arborescence d'installation de HPU
rem
rem

:UPDLINFILE

(echo.)                   >> "%FILE_TRACE%"
(echo ^>^>^> UPDLINFILE)  >> "%FILE_TRACE%"

set RETURN_CODE=0

set ARG_1=%~1
set ARG_2=%~2
set ARG_3=%~3
set ARG_4=%~4

if "%ARG_1%" == "" (
   echo Missing arguments  >> "%FILE_TRACE%"
   echo Missing arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)

if not "%ARG_4%" == "" (
   echo Too many arguments  >> "%FILE_TRACE%"
   echo Too many arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)

rem echo 1 : "%1"
rem echo 2 : "%2"
rem echo 3 : "%3"
rem echo 4 : "%4"


if "%CONTEXT%" == "INST" (
rem echo Action UPDATE_LINE_FILE INST
call :UPDLIF_INST %*
) else (


if "%CONTEXT%" == "UNINST" (
rem echo Action UPDATE_LINE_FILE UNINST
call :UPDLIF_UNINST %*
)

)

(echo.)                        >> "%FILE_TRACE%"
(echo ^>^>^> UPDLINFILE exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem UPDPLG_INST
rem #########################################################################

rem
rem Action UPDATE_PLUGIN mode installation
rem

:UPDPLG_INST

(echo.)                     >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLG_INST)   >> "%FILE_TRACE%"

set RETURN_CODE=0

set ARG_1=%1


rem Argt non exploite !!!???


if not exist "%DIR_UPDATE%\!ARG_1!" (
   echo Directory "%DIR_UPDATE%\!ARG_1!" not found  >> "%FILE_TRACE%"
   echo Directory "%DIR_UPDATE%\!ARG_1!" not found 1>&2
   set RETURN_CODE=2
   goto :EOF
)


echo.                     >> "%FILE_TRACE%"
echo Updating plug-in...  >> "%FILE_TRACE%"
echo.                     >> "%FILE_TRACE%"


if not exist "%LOCATION_PATH%\java" (
   echo Directory "%LOCATION_PATH%\java" not found  >> "%FILE_TRACE%"
   echo Directory "%LOCATION_PATH%\java" not found 1>&2
   set RETURN_CODE=2
   goto :EOF
)

cd /d "%LOCATION_PATH%\java"

echo.                     >> "%FILE_TRACE%"
echo Backing up classes   >> "%FILE_TRACE%" 
xcopy classes classes_%UPDATE_LABEL% /i/v/s/e/y    >> "%FILE_TRACE%"

echo.                   >> "%FILE_TRACE%"
echo Updating classes   >> "%FILE_TRACE%"
xcopy "%DIR_UPDATE%\java\classes" classes /i/v/s/e/y    >> "%FILE_TRACE%"


cd classes

echo.                                                >> "%FILE_TRACE%"
(echo Removing actual classes in ZIP archive file)   >> "%FILE_TRACE%"
"%LOCATION_PATH%\install\zip" -rq "%DB2_DIR%\db2plug.zip" -d com\ibm\inz*    >> "%FILE_TRACE%"


echo.                                             >> "%FILE_TRACE%"
echo Adding updated classes in ZIP archive file   >> "%FILE_TRACE%"
"%LOCATION_PATH%\install\zip" -r0D "%DB2_DIR%\db2plug.zip" *    >> "%FILE_TRACE%"

rem Restauration repertoire courant
cd /d "%DIR_UPDATE%"


(echo.)                         >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLG_INST exit)  >> "%FILE_TRACE%"


goto :EOF



rem #########################################################################
rem UPDPLG_UNINST
rem #########################################################################

rem
rem Action UPDATE_PLUGIN mode desinstallation
rem

:UPDPLG_UNINST

(echo.)                      >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLG_UNINST)  >> "%FILE_TRACE%"

set RETURN_CODE=0

set ARG_1=%1


rem Argt non exploite !!!


echo.                    >> "%FILE_TRACE%"
echo Restoring plug-in   >> "%FILE_TRACE%"
echo.  >> "%FILE_TRACE%"

if not exist "%LOCATION_PATH%\java" (
   echo Directory "%LOCATION_PATH%\java" not found  >> "%FILE_TRACE%"
   echo Directory "%LOCATION_PATH%\java" not found 1>&2
   set RETURN_CODE=2
   goto :EOF
)

rem Controle par securite
if not exist "%LOCATION_PATH%\java\classes_%UPDATE_LABEL%" (
   echo Directory "%LOCATION_PATH%\java\classes_%UPDATE_LABEL%" not found  >> "%FILE_TRACE%"
   echo Directory "%LOCATION_PATH%\java\classes_%UPDATE_LABEL%" not found 1>&2
   set RETURN_CODE=2
   goto :EOF
)


cd /d "%LOCATION_PATH%\java"


echo.                             >> "%FILE_TRACE%"
echo Removing classes directory   >> "%FILE_TRACE%"
rmdir /s/q classes  


echo.                              >> "%FILE_TRACE%"
echo Restoring classes directory   >> "%FILE_TRACE%"
xcopy "classes_%UPDATE_LABEL%" classes /i/v/s/e    >> "%FILE_TRACE%"



echo.                                   >> "%FILE_TRACE%"
echo Removing unused classes directory  >> "%FILE_TRACE%"
rmdir  /s/q  "classes_%UPDATE_LABEL%"



cd classes
 
echo.                                               >> "%FILE_TRACE%"
echo Removal of classes files in ZIP archive file   >> "%FILE_TRACE%"
"%LOCATION_PATH%\install\zip" -rq "%DB2_DIR%\db2plug.zip" -d com\ibm\inz*   >> "%FILE_TRACE%"



echo.                                      >> "%FILE_TRACE%"
echo Adding classes files in ZIP archive   >> "%FILE_TRACE%"
"%LOCATION_PATH%\install\zip" -r0D "%DB2_DIR%\db2plug.zip" *    >> "%FILE_TRACE%"

rem Restauration repertoire courant
cd /d "%DIR_UPDATE%"
 

(echo.)  >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLG_UNINST exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem UPDPLGIN
rem #########################################################################

rem
rem Action UPDATE_PLUGIN
rem
rem Un conditionnement avec STANDALONE_INSTALLATION est integre directement 
rem dans le script.
rem Pas de condition parametrable dans le fichier d'action
rem

:UPDPLGIN

(echo.)                 >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLGIN)  >> "%FILE_TRACE%"

set RETURN_CODE=0

rem echo 1 : "%1"
rem echo 2 : "%2"
rem echo 3 : "%3"
rem echo 4 : "%4"

set ARG_1=%~1
set ARG_2=%~2
set ARG_3=%~3
set ARG_4=%~4

if "%ARG_1%" == "" (
   echo Missing arguments  >> "%FILE_TRACE%"
   echo Missing arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)

if not "%ARG_2%" == "" (
   echo Too many arguments  >> "%FILE_TRACE%"
   echo Too many arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)


if %STANDALONE_INSTALLATION% == 1 (
   (echo     No plug-in to update)  >> "%FILE_TRACE%"
   goto :EOF
)

if "%CONTEXT%" == "INST" (
rem Action UPDATE_PLUGIN INST
call :UPDPLG_INST %*
) else (


if "%CONTEXT%" == "UNINST" (
rem Action UPDATE_PLUGIN UNINST
call :UPDPLG_UNINST %*
)

)

(echo.)                      >> "%FILE_TRACE%"
(echo ^>^>^> UPDPLGIN exit)  >> "%FILE_TRACE%"


goto :EOF




rem #########################################################################
rem EXECUTE_FILE_ACTION
rem #########################################################################

rem
rem Execution des actions contenues dans un fichier d'actions
rem

:EXECUTE_FILE_ACTION

(echo.)                            >> "%FILE_TRACE%"
(echo ^>^>^> EXECUTE_FILE_ACTION)  >> "%FILE_TRACE%"

if "%1" == "" (
   echo Missing arguments >> "%FILE_TRACE%"
   echo Missing arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)

if not "%2" == "" (
   echo Too many arguments >> "%FILE_TRACE%"
   echo Too many arguments 1>&2
   set RETURN_CODE=1
   goto :EOF
)

set FILE_ACTION=%1

echo     FILE_ACTION     : "%FILE_ACTION%"  >> "%FILE_TRACE%"

rem Controles existence
if not exist "%FILE_ACTION%" (
(echo File "%FILE_ACTION%" not found) 1>&2
set RETURN_CODE=1
goto :EOF
)



rem Les lignes entierement vides sont sautees par "for"
rem for /f "usebackq tokens=1* delims==" %%a in (`type %FICHIER%`) do (
for /f "usebackq tokens=*" %%w in (`type "%FILE_ACTION%"`) do (

rem echo.

set LINE=%%w

rem echo LINE  : "!LINE!"


rem Une ligne entierement vide n'est pas detectee par le "for"
rem Une ligne contenant des espaces est lue comme vide
if "!LINE!" == "" (
rem Ligne vide qui contenait des espaces 
echo     Write of empty line  >> "%FILE_TRACE%"

) else (

set CAR=!LINE:~0,1!

rem echo CAR : "!CAR!"

if "!CAR!" == "#" (
rem echo Commentaire

) else (

rem Separation de la ligne

for /f "usebackq tokens=1* " %%a in (`echo !LINE!`) do (
set NAME_ACTION=%%a
set ARGUMENT_ACTION=%%b
)


echo     NAME_ACTION     : "!NAME_ACTION!"      >> "%FILE_TRACE%"
echo     ARGUMENT_ACTION : "!ARGUMENT_ACTION!"  >> "%FILE_TRACE%"


rem Pour conserver les arguments d'une action avec leur espaces eventuels :
rem passage de ces arguments en parametres d'appel de EXECUTE_ACTION
call :EXECUTE_ACTION !ARGUMENT_ACTION!



)



)

rem echo.

)

(echo.)                                 >> "%FILE_TRACE%"
(echo ^>^>^> EXECUTE_FILE_ACTION exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem EXECUTE_ACTION
rem #########################################################################

rem
rem Arguments d'appel :
rem 1 : arguments de l'action a executer
rem
rem Attention : utilisation de NAME_ACTION initialisee par la fonction appelante
rem (a ameliorer)
rem


:EXECUTE_ACTION

(echo.)                       >> "%FILE_TRACE%"
(echo ^>^>^> EXECUTE_ACTION)  >> "%FILE_TRACE%"


rem echo 1 : "%1"
rem echo 2 : "%2"
rem echo 3 : "%3"
rem echo 4 : "%4"

echo     NAME_ACTION : "%NAME_ACTION%"  >> "%FILE_TRACE%"
echo.                                   >> "%FILE_TRACE%"

if "%NAME_ACTION%" == "UPDATE_DIRECTORY" (
echo UPDATE_DIRECTORY action ==========================================  >> "%FILE_TRACE%"
call :UPDDIR %*
goto RC_EXE_ACTION
)


if "%NAME_ACTION%" == "UPDATE_LINE_FILE" (
echo UPDATE_LINE_FILE action ==========================================  >> "%FILE_TRACE%"
call :UPDLINFILE %*
goto RC_EXE_ACTION
)



if "%NAME_ACTION%" == "UPDATE_PLUGIN" (
echo UPDATE_PLUGIN action =============================================  >> "%FILE_TRACE%"
call :UPDPLGIN %*
goto RC_EXE_ACTION
)

echo Unknown action "%NAME_ACTION%"   >> "%FILE_TRACE%"
echo Unknown action "%NAME_ACTION%"   1>&2
set RETURN_CODE=1
goto END_EXE_ACTION

:RC_EXE_ACTION

if %RETURN_CODE% neq 0 (
   echo Error detected following action execution of "!NAME_ACTION! %*"  >> "%FILE_TRACE%"
   echo RETURN_CODE : %RETURN_CODE%                                      >> "%FILE_TRACE%"

   echo Error detected following action execution of "!NAME_ACTION! %*" 1>&2
)

:END_EXE_ACTION
(echo.)                            >> "%FILE_TRACE%"
(echo ^>^>^> EXECUTE_ACTION exit)  >> "%FILE_TRACE%"


goto :EOF



rem #########################################################################
rem EXE_ACTIONS
rem #########################################################################

rem
rem Execution de tous les fichiers d'actions passe en argument (en liste)
rem

:EXE_ACTIONS

(echo.)                    >> "%FILE_TRACE%"
(echo ^>^>^> EXE_ACTIONS)  >> "%FILE_TRACE%"

:L_EXE_ACTIONS

rem echo 1 : "%1"

if not exist "%1" (
echo File "%1" not found
rem Retour erreur ???!!
goto :EOF
)


call :EXECUTE_FILE_ACTION %1
shift
if not "%1" == "" goto :L_EXE_ACTIONS




(echo.)                         >> "%FILE_TRACE%"
(echo ^>^>^> EXE_ACTIONS exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem EXTRACT_BEGINNING_LINE
rem #########################################################################

rem Valeur en sortie : LINE_BEGINNING
rem
rem Ajouter controle args d'appel <<<<


:EXTRBEGLIN

(echo.)                               >> "%FILE_TRACE%"
(echo ^>^>^> EXTRACT_BEGINNING_LINE)  >> "%FILE_TRACE%"


set LINE_BEGINNING=
set CPT=%1
set LINE_COPY=%~2

:BCL_DEB_LIGNE

set CHAR=!LINE_COPY:~0,1!

set LINE_COPY=!LINE_COPY:~1!

rem echo LINE_COPY : "%LINE_COPY%"  >> "%FILE_TRACE%"
rem echo CHAR      : "%CHAR%"  >> "%FILE_TRACE%"

set /a CPT-=1

set LINE_BEGINNING=%LINE_BEGINNING%%CHAR%
rem echo LINE_BEGINNING : "%LINE_BEGINNING%"  >> "%FILE_TRACE%"

rem echo.
rem echo CPT : %CPT%

if "!LINE_COPY!" == "" goto :END_DEB_LIGNE

if "%CPT%" neq "0" goto :BCL_DEB_LIGNE

:END_DEB_LIGNE

(echo.)                                    >> "%FILE_TRACE%"
(echo ^>^>^> EXTRACT_BEGINNING_LINE exit)  >> "%FILE_TRACE%"


goto :EOF



rem #########################################################################
rem REVERSE_FILE
rem #########################################################################

rem Argument
rem 1 : fichier dont on veut onverser les lignes
rem 2 : fichier resultat de l'inversion

rem Resultat : VAL_CPT

:REVERSE_FILE

(echo.)  >> "%FILE_TRACE%"
(echo ^>^>^> REVERSE_FILE)  >> "%FILE_TRACE%"

if "%1" == "" (
echo Erreur sur le nombre d'arguments de l'action : pas assez d'arguments 
rem Retour erreur ???!!
goto :EOF
)

if not "%3" == "" (
echo Erreur sur le nombre d'arguments : trop d'arguments
rem Retour erreur ???!!
goto :EOF
)
set FILE=%~1
set FILE_NUMBERED=%FILE%_numbered
set FILE_REVERSED=%~2

del %FILE_NUMBERED% >NUL 2>&1
del %FILE_REVERSED% >NUL 2>&1


set NUM_LINE=0

rem Numerotation du fichier
rem On suppose qu'il y a moins de 1000 lignes

for /f "usebackq tokens=*" %%w in (`type "%FILE%"`) do (

rem echo.
set /a NUM_LINE=NUM_LINE+1
set LINE=%%w
rem echo     LINE  : "!LINE!"
rem echo     NUM_LINE : !NUM_LINE!

set NUM_LINE_OUTPUT=!NUM_LINE!

rem Rajout des zeros

rem Calcul de la longueur
set VAL_TMP=!NUM_LINE_OUTPUT!
set VAL_CPT=1


call :LENGTH !NUM_LINE_OUTPUT!
rem echo Longueur VAL_CPT : !VAL_CPT!

rem Rajout des zeros non significatifs (sur 3 positions au max)
if !VAL_CPT! leq 3 (set /a NB_ITER=3 - VAL_CPT

for /l %%n in (1 , 1 , !NB_ITER!) do set NUM_LINE_OUTPUT=0!NUM_LINE_OUTPUT!
) else (
rem Reinitialisation a 000
set NUM_LINE_OUTPUT=000
)

rem echo     NUM_LINE_OUTPUT : "!NUM_LINE_OUTPUT!"

(echo !NUM_LINE_OUTPUT!@!LINE!) >> %FILE_NUMBERED%

)


rem Tri du fichier en sens inverse

rem echo.
rem echo Apres tri...

for /f "usebackq delims=@ tokens=1*" %%w in (`sort /r "%FILE_NUMBERED%"`) do (

rem echo w : "%%w"
rem echo x : "%%x"
set LINE=%%x
rem echo LINE : "!LINE!"
(echo !LINE!) >> %FILE_REVERSED%
)

del %FILE_NUMBERED% >NUL 2>&1


(echo.)  >> "%FILE_TRACE%"
(echo ^>^>^> REVERSE_FILE exit)  >> "%FILE_TRACE%"


goto :EOF


rem #########################################################################
rem CHK_EMPTY_FILE
rem #########################################################################

:CHK_EMPTY_FILE


if %1"VIDE" == "VIDE" goto ERR_PARAM

if not exist "%~1" goto ERR_NON_EXISTENT


set SIZE=%~z1


rem echo Taille : %SIZE%

if %SIZE% EQU 0 goto SUITE_ZERO
if %SIZE% NEQ 0 goto SUITE_NON_ZERO


:SUITE_ZERO

rem File of zero size
set STATUS_CODE=0
goto :FIN_CHK_EMPTY_FILE


:SUITE_NON_ZERO

rem File of non zero size
set STATUS_CODE=29

goto :FIN_CHK_EMPTY_FILE

:FIN_CHK_EMPTY_FILE
exit /b %STATUS_CODE%


rem #########################################################################
rem TRIM_LEFT
rem #########################################################################

:TRIM_LEFT

set CAR=!NAME:~0,1!
rem echo CAR : "!CAR!"

:LOOP_TL
if "!CAR!" == " " (
rem echo 1er caractere : espace
set NAME=!NAME:~1!
rem echo NAME : "!NAME!"
set CAR=!NAME:~0,1!
goto LOOP_TL
) else (
goto :EOF
)



rem #########################################################################
rem TRIM_RIGHT
rem #########################################################################


:TRIM_RIGHT

set CAR=!NAME:~-1!
rem echo CAR : "!CAR!"

:LOOP_TR
if "!CAR!" == " " (
rem echo dernier caractere : espace
set NAME=!NAME:~-0,-1!
rem echo NAME : "!NAME!"
set CAR=!NAME:~-1!
rem echo CAR : "!CAR!"
goto LOOP_TR
) else (
goto :EOF
)


rem #########################################################################
rem LENGTH
rem #########################################################################

rem Argument
rem 1 : chaine a traiter
rem Attention : la chaine a traiter a ses doubles quotes qui la delimitent
rem supprimes.
rem
rem Resultat : VAL_CPT

:LENGTH

set VAL_TMP=%~1
set VAL_CPT=1

:LOOP_LENGTH

set VAL_TMP=!VAL_TMP:~1!
rem echo VAL_TMP : "!VAL_TMP!"
if not "!VAL_TMP!" == "" (
rem echo Non vide
set /a VAL_CPT+=1
rem echo VAL_CPT : !VAL_CPT!

goto LOOP_LENGTH
)

goto :EOF


rem #########################################################################
rem EVALUATE
rem #########################################################################

rem
rem "Evaluation" d'une chaine de la forme "%identificateur%" pour 
rem obtenir sa valeur
rem 

:EVALUATE

rem echo.
rem echo Evaluation
rem echo.

set ARG=%~1
rem echo ARG : %ARG%
rem echo.

set ARG_EVAL=%ARG%

goto :EOF


rem #######################################################################
rem #  
rem #######################################################################

:ERR_HPU_VERSION
echo Error while determining DB2 version >> "%FILE_TRACE%"
echo Error while determining DB2 version
goto END





:ABORT_INST
echo Aborting installation >> "%FILE_TRACE%"
echo Aborting installation
goto END


:ABORT_UNINST
echo Aborting uninstallation >> "%FILE_TRACE%"
echo Aborting uninstallation
goto END



:ERR_CFG
echo Error file "%LOCATION_PATH%\cfg\db2hpu.cfg" not found >> "%FILE_TRACE%"
echo Error file "%LOCATION_PATH%\cfg\db2hpu.cfg" not found
goto END


:ERR_DB2_VERSION
echo Error while determining DB2 version >> "%FILE_TRACE%"
echo Error while determining DB2 version
goto END


:ERR_PARAM
echo Bad parameters
goto END


:ERR_PAR1
echo Parameter 1 must be "INST" or "UNINST"
goto END


:ERR_CONTEXT
echo Error on context value : %CONTEXT% >> "%FILE_TRACE%"
echo Error on context value : %CONTEXT%
goto END


:ERR_NOT_FOUND
echo Archive file not found >> "%FILE_TRACE%"
echo Archive file not found
goto END


:ERR_DOS
echo Unknown DOS version >> "%FILE_TRACE%"
echo Unknown DOS version
goto END
  
  
:ERR_DB2_LOCATION
echo Error while determining DB2 location >> "%FILE_TRACE%"
echo Error while determining DB2 location
goto END




:END
  
